package tr.edu.bilkent.cs.partitioning.ccp.hetccp;

import tr.edu.bilkent.cs.partitioning.ccp.PartitionImpl;
import tr.edu.bilkent.cs.partitioning.ccp.PrefixSum;

/**
 * HetPartitionImpl.
 * <p>
 * Date: 03.02.2006
 */
public class HetPartitionImpl extends PartitionImpl {
    private PrefixSum e;

    /**
     * ctor.
     *
     * @param e processor chain.
     * @param n number of tasks.
     */
    public HetPartitionImpl(PrefixSum e, int n) {
        super(e.size(), n);
        this.e = e;
    }

    @Override
    protected double getNeckValue(int i, int pre, int p) {
        return super.getNeckValue(i, pre, p) / e.getAt(p);
    }

    @Override
    public String toString() {
        StringBuilder buf = new StringBuilder(super.toString());
        buf.append(" {");
        for (int i = 0; i < e.size(); i++) {
            if (i != 0) {
                buf.append(", ");
            }
            buf.append(e.getAt(i));
        }
        buf.append('}');
        return buf.toString();
    }
}
