package tr.edu.bilkent.cs.partitioning.ccp.hetccp;

/**
 * Interval interface.
 * Represents a single one-dimensional integer interval, with first and last integer values.
 */
public interface Interval {
    /**
     * getter for first: the start integer of the interval.
     *
     * @return start of interval
     */
    int getFirst();

    /**
     * setter for first
     *
     * @param first start of interval
     */
    void setFirst(int first);

    /**
     * getter for last: end of interval.
     *
     * @return last
     */
    int getLast();

    /**
     * setter for last
     *
     * @param last end of interval
     */
    void setLast(int last);

    /**
     * returns whether first reached or passed last.
     *
     * @return whether interval converged: first &gt;= last.
     */
    boolean converged();

    /**
     * returns the midpoint of first and last.
     *
     * @return midpoint: (first+last)/2
     */
    int getMidPoint();
}
