package tr.edu.bilkent.cs.partitioning.ccp.hetccp;

import tr.edu.bilkent.cs.partitioning.ccp.PrefixSum;

/**
 * LRProbe interface.
 * <p>
 * The LRProbe contract and the implementations are presented in:
 * A. Pinar, K. Tabak, C. Aykanat, One-Dimensional Partitioning for Heterogeneous Systems: Theory and Practice,
 * J. of Parallel and Distributed Computing, 2008.
 */
public interface LRProbe {
    /**
     * probes the workload array on processors for the candidate bottleneck value.
     *
     * @param workloadPs prefix-summed workload array
     * @param processors prefix-summed processor speeds.
     * @param candidate candidate bottleneck value.
     * @return probe result.
     */
    ProbeResult probe(PrefixSum workloadPs, PrefixSum processors, double candidate);
}
