package tr.edu.bilkent.cs.partitioning.ccp.hetccp;

@SuppressWarnings({"UtilityClass"})
public class Probe1DFactory {
    /**
     * The singleton counter instance for probe calls.
     */
    private static final Counter counter = new CounterImpl();
    /**
     * Probe1D singleton instance.
     */
    private static final Probe1D impl = new Probe1DImpl(counter);
    /**
     * LRProbe singleton instance.
     */
    private static final LRProbe lrImpl = new LRProbeImpl(counter);
    /**
     * RL-Probe singleton instance.
     */
    private static final LRProbe rlImpl = new RLProbeImpl(counter);

    /**
     * returns the counter value for the probe calls.
     *
     * @return counter value.
     */
    public static int getCount() {
        return counter.getCount();
    }

    /**
     * resets counter to zero.
     */
    public static void resetCount() {
        counter.resetCount();
    }

    /**
     * getter for probe1DImpl
     *
     * @return probe1DImpl.
     */
    public static Probe1D getProbe1DImpl() {
        return impl;
    }

    /**
     * getter for lrProbeImpl.
     *
     * @return lrProbeImpl
     */
    public static LRProbe getLRProbeImpl() {
        return lrImpl;
    }

    /**
     * getter for rl-probe implementation.
     *
     * @return rl-probe implementation
     */
    public static LRProbe getRLProbeImpl() {
        return rlImpl;
    }
}
