package tr.edu.bilkent.cs.partitioning.ccp.hetccp;

import tr.edu.bilkent.cs.partitioning.ccp.PrefixSum;

/**
 * Implementation of the Probe1D interface.
 */
public class Probe1DImpl implements Probe1D {
    /**
     * counter for probe calls.
     */
    private Counter counter;

    /**
     * Constructor
     *
     * @param counter injected counter instance.
     */
    public Probe1DImpl(Counter counter) {
        this.counter = counter;
    }

    public boolean probe(PrefixSum workloadPs, PrefixSum processors, double candidate) {
        counter.incrementCount();
        int p = processors.size();
        int sn = workloadPs.size();
        double bsum = 0;
        for (int i=0; i<p; i++){
            bsum += processors.getAt(i) * candidate;
            int sp = workloadPs.searchLessThan(bsum);
            if (sp==sn-1){
                return true;
            }
            bsum = workloadPs.get(sp);
        }
        return false;
    }
}
