package tr.edu.bilkent.cs.partitioning.ccp.hetccp;

import tr.edu.bilkent.cs.partitioning.ccp.Partition;

/**
 * Implementation of SeparatorBounds.
 */
public class SeparatorBoundsImpl implements SeparatorBounds {
    /**
     * highs.
     */
    private int[] high;

    /**
     * lows.
     */
    private int[] low;

    /**
     * probevalue.
     */
    private double probeValue;

    /**
     * Constructor.
     *
     * @param high highs
     * @param low lows
     * @param probeValue probe value
     */
    public SeparatorBoundsImpl(int[] high, int[] low, double probeValue) {
        this.high = high;
        this.low = low;
        this.probeValue = probeValue;
    }

    public int getLow(int p) {
        return low[p];
    }

    public int getHigh(int p) {
        return high[p];
    }

    public double getProbeValue() {
        return probeValue;
    }

    public void updateWithProbedPartition(Partition partition, int p) {
        int[] highs = partition.getSeps();
        int length = highs.length;
        System.arraycopy(highs, p, high, p, length - p);
    }

    public void updateWithFailedProbe(Partition partition, int p) {
        int[] lows = partition.getSeps();
        int length = lows.length;
        System.arraycopy(lows, p, low, p, length - p);
    }
}
