package tr.edu.bilkent.cs.partitioning.ccp.hetccp.cp;

import tr.edu.bilkent.cs.partitioning.ccp.PrefixSum;
import tr.edu.bilkent.cs.partitioning.ccp.Partition;

/**
 * The interface of all cp algorithms.
 */
public interface Cp {
    /**
     * The implementations are required to return partition instances.
     *
     * @param wSum the prefix-summed task array.
     * @param pSum the prefix-summed processor speed array.
     * @param k seed value.
     * @return the partition.
     */
    Partition calculatePartition(PrefixSum wSum, PrefixSum pSum, int k);
}
